//
// PLBot - OLO's bot (based on HPB_player_temp # 2)
//
// (http://www.olo.counter-strike.pl/)
//
// bot.cpp
//
// PLBOT 099 "22 XII Internet??? CDR"

/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>

#include "bot.h"
#include "plbot_api.h"  // me

void BotThink( player_t *pBot )
{
   static edict_t *pEdict;
   pEdict = pBot->pEdict;
   static bool dont_see_enemy;
   dont_see_enemy = TRUE;

   // adjust the millisecond delay based on the frame rate interval...
   if (pBot->msecdel <= gpGlobals->time)
   {
      pBot->msecdel = gpGlobals->time + 0.5;
      if (pBot->msecnum > 0)
         pBot->msecval = 450.0/pBot->msecnum;
      pBot->msecnum = 0;
   }
   else
      pBot->msecnum++;
   if (pBot->msecval < 1)
      pBot->msecval = 1;   // don't allow msec to be less than 1...
   if (pBot->msecval > 100)
      pBot->msecval = 100; // ...or greater than 100

   if (pBot->not_started)
   {
      //Join to the team
      // handle Counter-Strike stuff here...
      if (pBot->start_action == MSG_CS_TEAM_SELECT)
      {
         pBot->start_action = MSG_CS_IDLE;  // switch back to idle
         if (pBot->who_have_join < 1||pBot->who_have_join > 2)
            pBot->who_have_join = 5;
         FakeClientCommand(pBot->pEdict, "menuselect", UTIL_VarArgs("%d", pBot->who_have_join), NULL);
      }
      else if (pBot->start_action==MSG_CS_CT_SELECT||pBot->start_action==MSG_CS_T_SELECT)
      {
         pBot->start_action = MSG_CS_IDLE;  // switch back to idle
         if ((pBot->bot_class < 1) || (pBot->bot_class > 4))
            pBot->bot_class = 5;  // use random if invalid
         FakeClientCommand(pBot->pEdict, "menuselect", UTIL_VarArgs("%d", pBot->bot_class), NULL);
         pBot->not_started = FALSE;// bot has now joined the game (doesn't need to be started)
      }
      RUNPLAYERMOVE( pEdict, pEdict->v.v_angle, 0, 0, 0, pEdict->v.button, 0, pBot->msecval);
      return;
   }

   if (pBot->say_time < gpGlobals->time&&CPUusage(10))
      ApplyRadioCommand(pBot); //exec. radio commands..

   //Buy weapons If haven't done it yet..
   if  (!IsAlive(pEdict) || BotBuyEquip(pBot) || pEdict->v.maxspeed < 10)
   {
      RUNPLAYERMOVE(pEdict, pEdict->v.v_angle, 0, 0, 0, pEdict->v.button, 0, pBot->msecval);
      return;
   }

   //If is in bomb zone, defuse bomb or plant it.
   if (Maptype == DE_MAP && !pBot->pBotEnemy && OnBombZone(pBot))
   {
      BotChangeAngle(pEdict->v.angles.y, pBot->ideal_body, 5, TRUE);
      BotChangeAngle(pEdict->v.angles.x, pBot->ideal_bodyx, 5,TRUE);
      RUNPLAYERMOVE(pEdict, pEdict->v.v_angle, 0, 0, 0, pEdict->v.button, 0, pBot->msecval);
      return;
   }

   //Must be after these func above
   pEdict->v.button = 0;
   pBot->f_move_speed = pEdict->v.maxspeed + 20; //Set bot speed
   //Small hack which compensate no acceleration for bots

   // Duck during jumping or if we should go under
   //if (CheckIfCanDuck(pBot)) //|| ((pBot->duck_time > gpGlobals->time) && (pBot->duck_time < gpGlobals->time + 0.4)))
   // pEdict->v.button |= IN_DUCK;

   //Do we have jump?
   if ((CheckIfCanJumpWhole(pBot) || CheckIfCanJump(pBot, ignore_monsters)) && !(pBot->bot_action & BOT_DUCKING))
   {
      pEdict->v.button |= IN_JUMP;
   }
   else
   {
      //If we are executing special acrobation dont avoid walls
      //Navigate System which include avoiding wall
      //Going to the longest way, following nodes, Going to main objects and many others
      pEdict->v.ideal_yaw = UTIL_VecToAngles(NavigateMe(pBot)).y;
      BotChangeAngle(pBot->avoid_angle.y, pBot->pEdict->v.ideal_yaw, 6,FALSE);
   }
   //Make v_angle in this same direction as avoid (in this way bot will go where he should)
   pEdict->v.v_angle = pBot->avoid_angle;
   //So if end of rush time get objectives
   if ((pBot->rush_time == -1) && (!pBot->planedGoal))
      FindGoalTarget(pBot); //Find good goal

   //Find Enemy, check if our aliases lives
   if (CPUusage(10))
   {
      //So if we are not blind or don't have any smoke grenades, look for enemies
      if (pBot->blinded_time < gpGlobals->time)
         pBot->pBotEnemy = BotFindEnemy( pBot );
      else
         pBot->pBotEnemy = NULL;

      //Check if our enemy still alive If not remove him with about one second delay
      if (!IsAlive(pBot->pBotEnemy) && (pBot->bot_see_enemy_time > gpGlobals->time))
      {
         if ((pBot->bot_see_dead_time < gpGlobals->time) && (pBot->bot_see_dead_time != -1))
         {
            pBot->pBotEnemy = NULL;
            pBot->bot_see_dead_time = -1;
         }
         else if (pBot->bot_see_dead_time == -1)
         {
            pBot->bot_see_dead_time = gpGlobals->time + 0.3; //Shoot after dead for 0.3 second...
         }
      }
   }

   //We can throw greande so do it as fast as posiible
   //Well check if we have grenade correct grenade in heand!!!
   if (pBot->pBotEnemy)
   {
      // Enemy exist
      //If have rifle you we've better snipe
      if (HaveSniperRifle(pBot))
      {
         pBot->action_time = gpGlobals->time + 5;
         pBot->bot_action = BOT_DUCKING; //Snipe down
         pBot->bot_action |= BOT_STOPED;
      }

      //Check if we can throw grenade
      if (ThrowGrenade(pBot))
      {
         dont_see_enemy = FALSE; //Nothing else...
      }
      else if (IsAbleToHit(pBot))
      {
         //Enemy visible, try to aim and shoot
         //Trace enemy
         BotPointAt(pBot, GetGunPosition(pBot->pBotEnemy) - pEdict->v.origin, TRUE);
         dont_see_enemy = FALSE;

         if (pBot->shoot_time < gpGlobals->time)
         {
            //We have got weapons with two zoom modes so go in zoom mode
            if ((pBot->zoom_fov > 40) && (HaveTwoZoom(pBot)))
            {
               pBot->pEdict->v.button |= IN_ATTACK2;
               pBot->is_shooting++;
            }
            else  if ((pBot->zoom_fov == 90) && (HaveOneZoom(pBot)))
            {
               pBot->pEdict->v.button |= IN_ATTACK2;
               pBot->is_shooting++;
            }
            else if (pBot->is_shooting > 0)
            {
               pBot->is_shooting = 0;
               BotShootAtEnemy(pBot);
            }
            else
               pBot->is_shooting++; //Turn off don't shoot
         }

         if (pBot->lastNodes[0]) //Does we have alrady cleared?
            NullLastGoals(pBot); //Clear all used nodes

         //Save his position
         pBot->last_enemy_pos = pBot->pBotEnemy->v.origin;
         pBot->last_your_pos =  pEdict->v.origin; //Save bot position
      }
      else
      {
         //Choose fighting style (snipe down, sniper crouching)
         if (pBot->check_action_time < gpGlobals->time)
         {
            pBot->check_action_time = gpGlobals->time + 3;

            if (BotNoAction(pBot))
            {
               switch (Generate(3))
               {
               case 0:
                  pBot->bot_action = BOT_DUCKING;
                  pBot->action_time = gpGlobals->time + 4; //Make action ofr 5 sec...
                  break;
               case 1:
                  pBot->bot_action = BOT_DUCKING;
                  pBot->bot_action |= BOT_STOPED;
                  pBot->action_time = gpGlobals->time + 5;
                  break;
               }
            }
         }

         if (DecideToThrowGrenade(pBot))
         {
            pBot->bot_action |= BOT_STOPED; //Stop bot
            pBot->bot_action |= BOT_DUCKING;
            pBot->action_time = gpGlobals->time + 2; //It should take only 2 sec
         }

         //If bot is VIP don't try to fight with enemy again
         if (pBot->player_team & CLIENT_VIP)
            pBot->pBotEnemy = NULL;
      }

      //Hmmm... 20 sec is long enaught to stop hunting for enemy
      if (pBot->bot_see_enemy_time + 20 < gpGlobals->time)
         pBot->pBotEnemy = NULL;
   }
   //Here we don't have enemy so look around and spray logos ;D
   //Back to normal stage (no grenades or zooms)
   else
   {
      //Back to normal zoom scope
      if (pBot->zoom_fov != 90) //&& (HaveOneZoom(pBot) || HaveTwoZoom(pBot)))
         pBot->pEdict->v.button |= IN_ATTACK2;

      //No enemy and we have got greande in hands, switch to normal weapon
      if (HaveGrenadeInHand(pBot))
      {
         SwitchToWeapon(pBot);
         pBot->bot_action &= ~player_tHROW_HG;
         pBot->bot_action &= ~player_tHROW_SG;
         pBot->bot_action &= ~player_tHROW_FG;
      }
   }

   // Turn the body like human player
   if ((pBot->look_around_time < gpGlobals->time) && (dont_see_enemy) && (Chance(2)))
   {
      pBot->look_around_time = gpGlobals->time + RANDOM_FLOAT(0.05, 0.25);
      LookAround(pBot);
   }

   //Execute activites (stop moving, crouch, look around, etc...)
   //When time ends back to the first position
   BotUseAction(pBot);

   //Adjust angles of body - Resault like mouse emulation?
   BotChangeAngle(pBot->pEdict->v.angles.y, pBot->ideal_body, 5, TRUE);
   BotChangeAngle(pBot->pEdict->v.angles.x, pBot->ideal_bodyx, 5, TRUE);

   // see how far bot has moved since the previous position...
   if (BotNoAction(pBot) && (pBot->prev_time < gpGlobals->time))
   {
      pBot->moved_distance = (pBot->v_prev_origin - pEdict->v.origin).Length();
      // save current position as previous
      pBot->v_prev_origin = pEdict->v.origin;
      pBot->prev_time = gpGlobals->time + 0.5;
   }
   else
      pBot->moved_distance = 50.0;

   //Unstuck
   if (pBot->moved_distance <= 5.0 && !(pBot->bot_action & BOT_STOPED))
      pBot->avoid_angle.y += 120; //Turn off from obstacle

   //press reload button
   if ((pBot->bot_see_enemy_time > 0) && (pBot->bot_see_enemy_time + 6 < gpGlobals->time))
   {
      pBot->bot_see_enemy_time = -1;  // so we won't keep reloading
      pEdict->v.button |= IN_RELOAD;
   }

   //Try to find breakable object and shoot to them
   FoundBreakable(pBot); //?

   //Grab Hostage if can
   if (pBot->curr_hostage > 0)
      GrabHostage(pBot);

   //Switch to knife during rush time...
   if (pBot->rush_time > gpGlobals->time)
   {
      //If don't have knife during rush time and have no weapon on ground to pickup can switch to knife
      if (pBot->current_weapon.iId != CS_WEAPON_KNIFE && !pBot->pGroundWeapon)
         FakeClientCommand(pBot->pEdict, "weapon_knife",NULL,NULL);
   }
   else if (pBot->rush_time != -1)
   {
      //So if end of rush time get objectives
      pBot->rush_time = -1; //Do it once
      SwitchToWeapon(pBot); //Switch to the best weapon
   }

   RUNPLAYERMOVE(pEdict, pBot->avoid_angle, pBot->f_move_speed, 0, 0, pEdict->v.button, 0, pBot->msecval);
}

