//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_action.cpp
//
/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>
#include "bot.h"
#include "plbot_api.h"  // me

float angle_cos_15[24]=
   {0.00,0.26,0.50,0.71,0.87,0.97,1.00,0.97,0.87,0.71,0.50,0.26,0.00,
    -0.26,-0.50,-0.71,-0.87,-0.97,-1.00,-0.97,-0.87,-0.71,-0.50,-0.26};

float angle_sin_15[24]=
   {-1.00,-0.97,-0.87,-0.71,-0.50,-0.26,0.00,0.26,0.50,0.71,0.87,0.97,1.00,
    0.97,0.87,0.71,0.50,0.26,0.00,-0.26,-0.50,-0.71,-0.87,-0.97};

//Check here if bot can snipe, through grenade etc...
void BotFindAction(player_t *pBot, float EnemyDist, edict_t *pEnemy)
{
   //If already snipe dont check
   if (!BotNoAction(pBot) || (pBot->pBotEnemy) || (pBot->check_action_time > gpGlobals->time))
      return;
   pBot->check_action_time = gpGlobals->time + 4;

   TraceResult trEndAim;
   Vector v_forward, v_right;
   ANGLEVECTORS( pBot->pEdict->v.angles, v_forward, v_right, NULL );
   Vector vecSrc = pBot->pEdict->v.origin;

   //Decide here what action bot have to do
   //Enemy must be at the same floor
   if (OnThisSameLevel(vecSrc, pEnemy->v.origin , 250) == FALSE)
      return;
   //Enemy at this same level get shoot vector
   Vector vecAim = vecSrc + v_forward*1024;
   //Trace it and return end position of aiming
   UTIL_TraceLine( vecSrc, vecAim, ignore_monsters, ignore_glass, pBot->pEdict->v.pContainingEntity, &trEndAim);

   float ShootDist = (trEndAim.vecEndPos - vecSrc).Length();
   //Distance to snipe for Sniper Rifles
   if ((EnemyDist < 1024) && (ShootDist > 768) && (HaveSniperRifle(pBot)))
   {
      pBot->bot_action = BOT_DUCKING; //Snipe down
      pBot->bot_action |= BOT_STOPED;
      pBot->action_time = gpGlobals->time + 2;
   } //Distance to snipe for Rifles
   else if ((EnemyDist < 512) && (ShootDist < 768) && (ShootDist > 256) && (HaveRifle(pBot)))
   {
      pBot->bot_action = BOT_DUCKING; //Snipe down
      pBot->action_time = gpGlobals->time + 2;
   }
   else if (EnemyDist < 640)
   {
      pBot->bot_action = BOT_JUMPING;
      pBot->action_time = gpGlobals->time + 5;
   }
}

void BotUseAction( player_t *pBot)
{
   Vector vecSrc = pBot->pEdict->v.origin;

   //Here decide about position and speed of bot
   //If someone called 'GOGOGO' or 'FALLBACK'
   if (pBot->user_action & USER_GOGOGO)
   {
      //If the rush time end just stop bot and make him snipe down
      if (pBot->user_gogogo_time < gpGlobals->time)
      {
         pBot->action_time = gpGlobals->time + 5;
         pBot->bot_action = BOT_DUCKING; //Snipe down
         pBot->bot_action |= BOT_STOPED;
         pBot->user_action &= ~USER_FALLBACK;
      }
   }
   else if (pBot->user_action & USER_HOLD)
   {
      //If someone have to camp...
      float distance = (pBot->vecHoldPosition - vecSrc).Length2D();
      //If you are 200 unit from your holdposition point decide
      if ((distance > 150) && (BotNoAction(pBot)))
      {
         //To sniper or crouch else do nothing stund up and go
         switch (Generate(5))
         {
         case 0:
            pBot->bot_action = BOT_DUCKING; //Snipe down
            pBot->bot_action |= BOT_STOPED;
            break;
         case 1:
         case 2:
            pBot->bot_action = BOT_DUCKING; //Move ducking
         }
         pBot->action_time = gpGlobals->time + 5;
      }
   }
   else if (pBot->user_action & USER_FOLLOWME)
   {
      //If someone called for help...
      float distance = (pBot->pHelpme->v.origin - vecSrc).Length2D();
      //If we are close enough our user crouch and snipe in case
      //of stick together don't go if enemy spotted
      if ((distance < 150) && ((pBot->pBotEnemy == NULL) || (pBot->user_action & USER_STICK)))
      {
         if (pBot->user_action & USER_COVERME)
         {
            pBot->action_time = gpGlobals->time + 5;
            pBot->bot_action = BOT_DUCKING; //Snipe down
            pBot->bot_action |= BOT_STOPED;
         }
         pBot->f_move_speed = 0; //For Follow Me
      }
      else
      {
         //If we are far enough stop crouching and follow user
         pBot->bot_action = BOT_NOACTION;
      }
   }

   //Set proper position and speed
   if (pBot->bot_action & BOT_DUCKING)
      pBot->pEdict->v.button |= IN_DUCK;

   if (pBot->bot_action & BOT_STOPED)
      pBot->f_move_speed = 0;

   if ((pBot->bot_action & BOT_JUMPOFTEN) && Chance(80))
      pBot->pEdict->v.button |= IN_JUMP;

   if ((pBot->bot_action & BOT_JUMPING) && Chance(90))
      pBot->pEdict->v.button |= IN_JUMP;

   //If this is end of time back to your prevoius position else look around
   if ((pBot->action_time < gpGlobals->time) && (pBot->bot_action != BOT_NOACTION))
   {
      pBot->prev_time = gpGlobals->time + 4;
      pBot->bot_action = BOT_NOACTION;
   }
}

//Gets distances from envoirment
void LookAround(player_t *pBot)
{
   double x=0, y=0, z = 0;
   TraceResult trEnd;
   Vector appDir, lookDir, vecDest, v_forward, v_right, v_up,
   vecSrc = pBot->pEdict->v.origin;

   if (pBot->pBotEnemy) //Have enemy set base to his dir
      appDir = UTIL_VecToAngles(pBot->pBotEnemy->v.origin - vecSrc);
   if (pBot->trEnemy != g_vecZero && (pBot->trEnemy - vecSrc).Length() < btrace) //Not visible
      appDir = UTIL_VecToAngles(pBot->trEnemy - vecSrc);
   else if (pBot->planedGoal)
      appDir = UTIL_VecToAngles(pBot->planedGoal->v.origin - vecSrc);
   else //Make base on current gun position
      appDir = pBot->pEdict->v.angles;

   ANGLEVECTORS( appDir, v_forward, v_right, v_up );
   appDir = vecSrc + v_forward - vecSrc;
   // Make vectors...
   for (int i = 4; i <22; i=i+2)
   {
      x=bsee*angle_cos_15[i];
      y=bsee*angle_sin_15[i]; //z=y*pBot->groundAngle;
      vecDest = vecSrc + v_forward*y + v_right*x; //+ v_up*z;
      //Trace distance and find its end with wall
      UTIL_TraceLine( vecSrc, vecDest, ignore_monsters, ignore_glass, pBot->pEdict->v.pContainingEntity, &trEnd);

      appDir = appDir + (trEnd.vecEndPos - vecSrc);

#ifdef MY_DEBUGE_MODE

      if (developme & 16) //For development
         DrawBeam(listenserver_edict, vecSrc, trEnd.vecEndPos, 0, 255, 255);
#endif

   }
   //Get his Y to our direction
   pBot->ideal_body = UTIL_VecToAngles(appDir).y;
   //Stuff for random looking up and down
   float add_angle = RANDOM_FLOAT(-3, 3);
   //Check if can add angle to view body
   if (add_angle < 0)
   {
      if (pBot->pEdict->v.angles.x > -4 )
         pBot->ideal_bodyx += add_angle;
   }
   else
   {
      if (pBot->pEdict->v.angles.x < 6 )
         pBot->ideal_bodyx += add_angle;
   }
}
/*
//Gets distances from envoirment
void LookAround(player_t *pBot)
{
 double x=0, y=0, z = 0; TraceResult trEnd;
 Vector appDir, lookDir, vecDest;
 Vector vecSrc = pBot->pEdict->v.origin;//Get vecSrc...
 Vector v_forward, v_right, v_up;
 
 if (pBot->pBotEnemy) //Have enemy set base to his dir
  appDir = UTIL_VecToAngles(pBot->pBotEnemy->v.origin - vecSrc);
 if ((pBot->trEnemy != g_vecZero) && ((pBot->trEnemy - vecSrc).Length() < btrace)) //Not visible
  appDir = UTIL_VecToAngles(pBot->trEnemy - vecSrc);
 else if (Chance(8))//Some times turn in going dir
  appDir = pBot->avoid_angle;
 else //Make base on current gun position
  appDir = pBot->pEdict->v.angles;
 
 appDir.x = 0; appDir.z = 0; //UTIL_MakeVectors(appDir);
 ANGLEVECTORS( appDir, v_forward, v_right, v_up );
 appDir = vecSrc + v_forward - vecSrc;
 // Make vectors...
 for (int i = 0; i <7; i++) {
  x=bsee*angle_cos_30[i]; y=bsee*angle_sin_30[i];
  z=y*pBot->groundAngle;
  vecDest = vecSrc + v_forward*y + v_right*x + v_up*z;
  //Trace distance and find its end with wall
  UTIL_TraceLine( vecSrc, vecDest, ignore_monsters, ignore_glass, pBot->pEdict->v.pContainingEntity, &trEnd);
 
  //add to main direction
  //if (trEnd.flFraction >= 1.0) {
  appDir = appDir + (trEnd.vecEndPos - vecSrc);
 
  if (developme & 16) //For development
   DrawBeam(listenserver_edict, vecSrc, trEnd.vecEndPos, 0, 255, 255);
  //}
 }
 //Get his Y to our direction
 pBot->ideal_body = UTIL_VecToAngles(appDir).y;
 //Stuff for random looking up and down
 float add_angle = RANDOM_FLOAT(-3, 3);
 //Check if can add angle to view body
 if ((add_angle < 0) && (pBot->pEdict->v.angles.x > -4 ))
  pBot->ideal_bodyx += add_angle;
 else if ((add_angle > 0) && (pBot->pEdict->v.angles.x < 6 ))
  pBot->ideal_bodyx += add_angle;
}
*/
void BotFixAngle(float &angle)
{
   // check for wrap around of angle...
   if (angle > 180)
      angle -= 360;
   if (angle < -180)
      angle += 360;
}

float BotChangeAngle(float &angle_current, float ideal, float speed, bool body )
{
   float current ,current_180 ,diff;
   // check for wrap around of angle...
   BotFixAngle(ideal);
   current = angle_current;
   diff = abs(current - ideal);// find the difference in the current and ideal angle

   // check if the bot is already facing the idealpitch direction...
   if (diff <= 1)
      return diff;  // return number of degrees turned
   //If long distance to turn make it faster
   if (body)
   {
      if (diff > 120)
         speed = speed * 2; //120 degress so turn very fast
   }
   else
   {
      //So legs turn
      //Make it less toleran
      if (diff > 180)
         speed = speed * 2; //120 degress so turn very fast
   }

   // check if difference is less than the max degrees per turn
   if (diff < speed)
      speed = diff;  // just need to turn a little bit (less than max)

   if ((current >= 0) && (ideal >= 0))
   {
      // both positive
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }
   else if ((current >= 0) && (ideal < 0))
   {
      current_180 = current - 180;
      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else if ((current < 0) && (ideal >= 0))
   {
      current_180 = current + 180;
      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }

   // check for wrap around of angle...
   BotFixAngle(current);
   angle_current = current;
   return speed;  // return number of degrees turned
}

int InFieldOfView(player_t *pBot, Vector dest, float view_angle)
{
   // find angles from source to destination...
   Vector entity_angles = UTIL_VecToAngles( dest );
   // make yaw angle 0 to 360 degrees if negative...
   if (entity_angles.y < 0)
      entity_angles.y += 360;
   // make view angle 0 to 360 degrees if negative...
   if (view_angle < 0)
      view_angle += 360;
   // return the absolute value of angle to destination entity
   int angle = abs((int)view_angle - (int)entity_angles.y);
   if (angle > 180)
      angle = 360 - angle;
   return angle;
}

//Properly pointing with gun. Sets position of body, and can set properly vector of aiming
Vector BotPointAt(player_t *pBot , Vector v_target, bool visbility)
{
   // find angles from source to destination...
   Vector look = UTIL_VecToAngles( v_target );
   //Fix angle
   BotFixAngle(look.y);
   BotFixAngle(look.x);

   // set the body angles to point the gun correctly
   if (visbility)
   {
      pBot->ideal_bodyx = look.x / 3;
      pBot->ideal_body = look.y;
   }

   // adjust the view angle pitch to aim correctly
   look.x = -look.x;
   return look;
}
