//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_goals.cpp
//

/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>
#include "plbot_api.h"  // me




float bomb_check_time = 0.0;
edict_t *bombplaced = NULL;

hostage_struct hostage[12];
rescuezone_struct rescuezone[12];
vipescape_struct vipescape[12];
escapezone_struct escapezone[12];
bombzone_struct bombzone[12];
rushpoint_struct rushpoint[12];

int bomb_num = 0;
int vip_num = 0;
int escape_num = 0;
int rescue_num = 0;
int hostage_num = 0;
int rushpoint_num = 0;
int Maptype = -1;

void GoalsInit()
{
   bomb_num = 0;  //Bomb number
   vip_num = 0;  //Vip
   escape_num = 0; //Escape zone
   rescue_num = 0; //Rescue
   hostage_num = 0; //Number of hostages
   rushpoint_num = 0; //Reset rush points

   //reset values in hostage array
   for (int i=0; i < 10; i++)
   {
      hostage[i].pEdict = NULL;
      hostage[i].pPlayer = NULL;
      hostage[i].can_use = TRUE;
      hostage[i].prev_time = 0.0;
      hostage[i].prev_origin = Vector(9999.0,9999.0,9999.0);
   }
}

void FindRushPointNodes()
{
   edict_t *pFoundNode = NULL;

   //Find all navigate nodes
   while (pFoundNode=UTIL_FindEntityByClassname(pFoundNode, "info_node"))
   {
      if (pFoundNode->v.effects & EF_BRIGHTFIELD) //Does this node contain rush point flag?
      {
         rushpoint[rushpoint_num].place = pFoundNode->v.origin; //Save it's varaibles
         rushpoint[rushpoint_num].pEdict = pFoundNode;
         rushpoint_num++; //Increase numbers of rush point
      }
   }
}

void FindObjectives()
{
   //Stuct for found item
   edict_t *pent = NULL;

   //Initialize objectives
   GoalsInit();

   //Dependent on map search for diffrent objectives
   switch (Maptype)
   {
   case DE_MAP: //Demolish scenario map
      //Find bomb targets
      while (pent=UTIL_FindEntityByClassname(pent, "info_bomb_target"))
      {
         bombzone[bomb_num].place = VECBMODELORIGIN(pent);
         bombzone[bomb_num].pEdict = pent;
         bomb_num++;
      }
      //Also bomb targets can be saved as bomb func
      while (pent=UTIL_FindEntityByClassname(pent, "func_bomb_target"))
      {
         bombzone[bomb_num].place = VECBMODELORIGIN(pent);
         bombzone[bomb_num].pEdict = pent;
         bomb_num++;

      }
      break;
   case ES_MAP: //Escape scenario map
      //Search for escape zones
      while (pent=UTIL_FindEntityByClassname(pent, "func_escapezone"))
      {
         escapezone[escape_num].place = VECBMODELORIGIN(pent);
         escape_num++;
      }
      break;
   case AS_MAP: //Assasination map
      //Search for VIP safe zones
      while (pent=UTIL_FindEntityByClassname(pent, "func_vip_safetyzone"))
      {
         vipescape[vip_num].place = VECBMODELORIGIN(pent);
         vip_num++;
      }
      break;
   case CS_MAP: //Hostage rescue scenario
      //Serach for hostage rescue zone
      while (pent=UTIL_FindEntityByClassname(pent, "func_hostage_rescue"))
      {
         rescuezone[rescue_num].place = VECBMODELORIGIN(pent);
         rescue_num++;
      }
      //Serach for hostage rescue zone as infos
      while (pent=UTIL_FindEntityByClassname(pent, "info_hostage_rescue"))
      {
         rescuezone[rescue_num].place = VECBMODELORIGIN(pent);
         rescue_num++;
      }
      //Search for Hostages
      while (pent=UTIL_FindEntityByClassname(pent, "hostage_entity"))
      {
         hostage[hostage_num].pEdict = pent;
         hostage_num++;
      }
      break;
   }

   //Make that game know you have found map objectives
   not_found_goal = FALSE;
}

void FreeMyHostage(edict_t *pEntity)
{
   int index;
   //Free all your hostage
   for (int i=0; i < hostage_num; i++)
      if (hostage[i].pPlayer == pEntity)
      {
         //Get index of entity
         index = ENTINDEX(pEntity);
         //If bot decrease number of bhostage in use
         if (index != -1)
            bots[index].hostage_use--;
         //Null user
         hostage[i].pPlayer = NULL;
         hostage[i].can_use = TRUE;
      }
}

void FreeHostage(int i)
{
   //Index of player
   int index;
   //We have specifed hostage and free him
   if (i > -1)
   {
      index = ENTINDEX(hostage[i].pPlayer);
      bots[index].hostage_use--;
      hostage[i].pPlayer = NULL;
      hostage[i].can_use = TRUE;
      return;
   }

   //If bot belongs to you free him for others...
   for (i=0; i < hostage_num; i++)
   {
      index = ENTINDEX(hostage[i].pPlayer);
      bots[index].hostage_use--;
      hostage[i].pPlayer = NULL;
      hostage[i].can_use = TRUE;
   }
}

void CheckHostages()
{
   //Go through hostage array and check if hostages still alives or
   //are in use (incase some of bots don't get them)
   for (int i = 0; i < hostage_num; i++)
   {
      //If hostage is dead (not visible for all)
      if (hostage[i].pEdict->v.effects & EF_NODRAW)
      {
         FreeHostage(i);
         hostage[i].can_use = FALSE;
      }
      else //Bot is visible make him useable
      {
         //Here we check if hostage is moving (if not so he must be not taken)
         if (hostage[i].prev_time < gpGlobals->time)
         {
            hostage[i].prev_time = gpGlobals->time + 5;

            if ((hostage[i].pEdict->v.origin - hostage[i].prev_origin).Length() < 5)
            {
               hostage[i].prev_origin = hostage[i].pEdict->v.origin;
               FreeHostage(i);
            }
         }

         hostage[i].can_use = TRUE;
      }
   }
}

int FindHostage(player_t *pBot)
{
   Vector vecHostage, vecSrc = pBot->pEdict->v.origin;
   int counter = 0, host_num = -1;
   float distance, min_dist = 9999.0;

   //Go through hostage array
   for (int i = 0; i < hostage_num; i++)
   {
      //If hostage is dead (not visible for all)
      if (hostage[i].pEdict->v.effects & EF_NODRAW)
         continue;

      //No bot have this hostage and it is able to use
      if ((hostage[i].pPlayer == NULL) && (hostage[i].can_use))
      {
         //Save origin
         vecHostage = hostage[i].pEdict->v.origin;

         //If bot is visible get him
         if (FVisible( vecHostage, pBot->pEdict))
         {
            //Check distance
            distance = (vecHostage - vecSrc).Length();
            //If it is nearest from any other (if exist) take him first
            if (min_dist > distance)
            {
               min_dist = distance;
               host_num = i;
            }
         }
      }

      //Well bot is able to use and he is used by no one or you are the user
      if ((hostage[i].can_use) && ((hostage[i].pPlayer == NULL) || (hostage[i].pPlayer == pBot->pEdict)))
         counter++;
   }

   //Well no hostages, keep searching
   if (counter == 0)
      return -1;

   //You have got more hostages than can be get from map so start searching for rescue zone
   if (pBot->hostage_use >= counter)
      return -2;

   //Reurn hostage array ID which you want to take
   return host_num;
}

bool BotGetHostages(player_t *pBot, Vector &vecAvoid, float sens)
{
   Vector vecSrc = pBot->pEdict->v.origin;

   //We have got the hostage and see the rescue zone... Go get it...
   if ((pBot->curr_hostage == -2) && (pBot->hostage_use > 0))
   {
      for (int i = 0; i < rescue_num;i++)
      {
         if (FVisible((rescuezone[i].place + Vector(0,0,64)), pBot->pEdict))
         {
            NavigateCustomDir(pBot, vecSrc, rescuezone[i].place, vecAvoid,  2, sens);
            return TRUE;
         }
      }
   }
   //We have got a hostage so go get him
   else if (pBot->curr_hostage > -1) //&& (hostage[pBot->curr_hostage].pPlayer == NULL))
   {
      Vector vecHostSrc = hostage[pBot->curr_hostage].pEdict->v.origin;
      Vector vecHostDir = vecHostSrc - vecSrc;

      //Bot is visible so go to him
      if (FVisible(vecHostSrc, pBot->pEdict))
      {
         NavigateCustomDir(pBot, vecSrc, vecHostSrc, vecAvoid,  2, sens);
         BotPointAt(pBot, vecHostDir, TRUE);
         return TRUE;
      }
   }
   //Well we don't have any hostage so keep searching
   else if (CPUusage(30))
      pBot->curr_hostage = FindHostage(pBot);

   return FALSE;
}

bool GrabHostage(player_t *pBot)
{
   Vector vecSrc = pBot->pEdict->v.origin;
   Vector vecHostSrc = hostage[pBot->curr_hostage].pEdict->v.origin;
   Vector vecHostDir = vecHostSrc - vecSrc;

   //If we are close enough press USE key
   if (vecHostDir.Length2D() > 64)
      return FALSE;

   //Look at hostage (set v_angle vec) to get him
   pBot->pEdict->v.v_angle = BotPointAt(pBot, vecHostDir, TRUE);
   //Press Use button
   pBot->pEdict->v.button |= IN_USE;
   //Save player to array
   hostage[pBot->curr_hostage].pPlayer = pBot->pEdict;
   //Increase bot usage
   pBot->hostage_use++;
   //Set value to start searching
   pBot->curr_hostage = -1;

   return TRUE;
}

void FindBomb()
{
   //If bomb has already found or it's to early return
   if ((!bombnotfound) || (bomb_check_time > gpGlobals->time))
      return;

   edict_t *pent = NULL;

   //Search for droped backpack
   while ((bombdroped) && ((pent=UTIL_FindEntityByModelname(pent, "models/w_backpack.mdl")) != NULL))
   {
      bombplaced = pent;
      bombnotfound = FALSE;
      break;
   }

   //Or for planted bomb
   while ((bombplanted) && ((pent=UTIL_FindEntityByModelname(pent, "models/w_c4.mdl")) != NULL))
   {
      bombplaced = pent;
      bombnotfound = FALSE;
      break;
   }
}

bool OnBombZone(player_t *pBot)
{
   //Terrorist is in bomb zone so swhich to bomb and plant it!!!
   if (pBot->inbombzone)
   {
      //If not have bomb in hand select it
      if (pBot->current_weapon.iId != CS_WEAPON_C4)
         FakeClientCommand(pBot->pEdict, "weapon_c4",NULL,NULL);

      //Duck during planting
      pBot->pEdict->v.button |= IN_DUCK;
      //Keep planting
      pBot->pEdict->v.button |= IN_ATTACK;

      return TRUE;
   }

   edict_t *pFoundItem = Finditem(pBot, pBot->pEdict->v.origin, "models/w_c4.mdl", CLIENT_CT, 35, FALSE);

   //Counter-Terrorist is over the bomb so defuze it
   if (pFoundItem)
   {
      //Duck during defusing
      pBot->pEdict->v.button |= IN_DUCK;
      //Keep use key
      pBot->pEdict->v.button |= IN_USE;

      //Look at bomb during defusing
      pBot->pEdict->v.v_angle = BotPointAt(pBot, (pFoundItem->v.origin + Vector (0,0,-36)) - pBot->pEdict->v.origin, TRUE);

      return TRUE;
   }

   //Well there is no action to do with C4
   return FALSE;
}

bool BotGetToBombZone(player_t *pBot, Vector &vecAvoid, float sens)
{
   //If bot don't have bomb in arsenal don't check the bombzones or if already is in...
   if (((pBot->pEdict->v.weapons & (1<<CS_WEAPON_C4)) == FALSE) || (pBot->inbombzone))
      return FALSE;

   Vector vecSrc = pBot->pEdict->v.origin;

   //This is some disorder to make planting more natural
   Vector vecDis = Vector(RANDOM_LONG(-320,320),RANDOM_LONG(-320,320),0);

   for (int i = 0; i < bomb_num;i++)
   {
      //If bombzone is visible run to it and don't keep checking
      if (OnThisSameLevel(bombzone[i].place, vecDis, 128) && FVisible((bombzone[i].place + vecDis), pBot->pEdict))
      {
         NavigateCustomDir(pBot, vecSrc, bombzone[i].place, vecAvoid,  2, sens);
         return TRUE;
      }
   }

   return FALSE;
}

bool BotGetToC4(player_t *pBot, Vector &vecAvoid, float sens)
{
   //If bomb not founded don't even try to search for it
   if (bombnotfound)
      return FALSE;

   Vector vecSrc = pBot->pEdict->v.origin;

   //Two cases: one bomb has been planted and second bomb has been droped
   if ((((bombplanted) && (pBot->player_team & CLIENT_CT)) || ((bombdroped) && (pBot->player_team & CLIENT_TERRORIST)))
         && OnThisSameLevel(vecSrc, bombplaced->v.origin, 256))
   {
      //If C4 is visible run to it!!!
      if (FVisible(bombplaced->v.origin, pBot->pEdict))
      {
         NavigateCustomDir(pBot, vecSrc, bombplaced->v.origin, vecAvoid,  2, sens);
         return TRUE;
      }
   }

   return FALSE;
}

void FindGoalTarget(player_t *pBot)
{
   //Because we are looking for new target, clear all last used
   if (pBot->lastNodes[0]) //Does we have alrady cleared?
      NullLastGoals(pBot); //Clear all used nodes

   if (Maptype == DE_MAP)
   {
      if (pBot->player_team & CLIENT_TERRORIST)
      {
         if (bombdroped)
         {
            if (bombplaced)
            {
               //FakeClientCommand(pBot->pEdict, "say", "ide do lezcej bomby" , NULL);
               pBot->planedGoal = bombplaced;
            }
         }
         else
         {
            //FakeClientCommand(pBot->pEdict, "say", "ide na bombsite'a", NULL);
            pBot->planedGoal = bombzone[RANDOM_LONG(0,bomb_num - 1)].pEdict;
         }

      }
      else if (pBot->player_team & CLIENT_CT)
      {
         if ((bombplanted) && (bombplaced))
         {
            // FakeClientCommand(pBot->pEdict, "say", "ide na bombe" , NULL);
            pBot->planedGoal = bombplaced;
         }
         //Nothing
      }
   }
   else if (Maptype == CS_MAP)
   {
      if (pBot->player_team & CLIENT_TERRORIST)
      {
         pBot->planedGoal = hostage[RANDOM_LONG(0,hostage_num - 1)].pEdict;
         //Nothing
      }
      else if (pBot->player_team & CLIENT_CT)
      {
         pBot->planedGoal = hostage[RANDOM_LONG(0,hostage_num - 1)].pEdict;
      }
   }
   else if (Maptype == ES_MAP)
   {
      if (pBot->player_team & CLIENT_TERRORIST)
      {
         pBot->planedGoal = escapezone[RANDOM_LONG(0,escape_num - 1)].pEdict;
      }
      else if (pBot->player_team & CLIENT_CT)
      {
         //Nothing
      }
   }
   else if (Maptype == AS_MAP)
   {
      if (pBot->player_team & CLIENT_TERRORIST)
      {
         //Nothing
      }
      else if (pBot->player_team & CLIENT_CT)
      {
         pBot->planedGoal = vipescape[RANDOM_LONG(0,vip_num - 1)].pEdict;
      }
   }
}
